-----------------------------------------------------------------------------------------------
-- Client Lua Script for WalatikiCommander
-- Copyright (c) NCsoft. All rights reserved
-----------------------------------------------------------------------------------------------
-- By: Yabco
-- Version: 0.1.1 

require "Window"
 
-----------------------------------------------------------------------------------------------
-- WalatikiCommander Module Definition
-----------------------------------------------------------------------------------------------
local WalatikiCommander = {} 
 
-----------------------------------------------------------------------------------------------
-- Constants
-----------------------------------------------------------------------------------------------
local sCmdNewMaskWest = "New Moodie Mask: Bottom WEST!"
local sCmdNewMaskCenter = "New Moodie Mask: Bottom CENTER!"
local sCmdNewMaskTop = "New Moodie Mask: BRIDGE!"
local sCmdNewMaskEast = "New Moodie Mask: Bottom EAST!"
local sCmdNewMask30 = "30 Seconds Until New Mask Spawns"
local sCmdNewMask15 = "15 Seconds Until New Mask Spawns"
local sCmdNewMask5 = "5 Seconds Until New Mask Spawns"

local sCmdDefCarrier = "Defend Our Mask Carrier!"
local sCmdDefTunnel = "Defend Our Mask Carrier in TUNNEL!"
local sCmdDefWest = "Defend Our Mask Carrier on WEST side!"
local sCmdDefBridge = "Defend Our Mask Carrier on BRIDGE!"
local sCmdDefEast = "Defend Our Mask Carrier on EAST side!"

local sCmdAttCarrier = "Attack Enemy Mask Carrier!"
local sCmdAttTunnel = "Attack Enemy Mask Carrier in TUNNEL!"
local sCmdAttWest = "Attack Enemy Mask Carrier on WEST side!"
local sCmdAttBridge = "Attack Enemy Mask Carrier on BRIDGE!"
local sCmdAttEast = "Attack Enemy Mask Carrier on EAST side!"

local sCmdDef = "Defend Base!"
local sCmdDef1 = "1 Enemy at Base!"
local sCmdDef2 = "2 Enemies at Base!"
local sCmdDef3 = "3 Enemies at Base!"
local sCmdDef4 = "4 or More Enemies at Base!"

local sCmdSteal = "Steal Mask From Enemy!"
local sCmdSteal1 = "1 Enemy Defending Their Masks"
local sCmdSteal2 = "2 Enemies Defending Their Masks"
local sCmdSteal3 = "3 Enemies Defending Their Masks"
local sCmdSteal4 = "4 or More Enemies Defending Their Masks"

-- local sCmdtargetHeal = "Heal"
-- local sCmdTargetAssist = "Assist"
-- local sCmdTargetAttack = "Kill"
-- local sCmdTargetCC = "CC"
 
-----------------------------------------------------------------------------------------------
-- Initialization
-----------------------------------------------------------------------------------------------
function WalatikiCommander:new(o)
    o = o or {}
    setmetatable(o, self)
    self.__index = self 

    -- initialize variables here

    return o
end

function WalatikiCommander:Init()
	local bHasConfigureFunction = false
	local strConfigureButtonText = ""
	local tDependencies = {
		-- "UnitOrPackageName",
	}
    Apollo.RegisterAddon(self, bHasConfigureFunction, strConfigureButtonText, tDependencies)
end
 

-----------------------------------------------------------------------------------------------
-- WalatikiCommander OnLoad
-----------------------------------------------------------------------------------------------
function WalatikiCommander:OnLoad()
    -- load our form file
	Apollo.RegisterEventHandler("ChatMessage","OnChatMessage", self)
	self.xmlDoc = XmlDoc.CreateFromFile("WalatikiCommander.xml")
	self.xmlDoc:RegisterCallback("OnDocLoaded", self)
end

-----------------------------------------------------------------------------------------------
-- WalatikiCommander OnDocLoaded
-----------------------------------------------------------------------------------------------
function WalatikiCommander:OnDocLoaded()

	if self.xmlDoc ~= nil and self.xmlDoc:IsLoaded() then
	    self.wndMain = Apollo.LoadForm(self.xmlDoc, "WalatikiCommanderForm", nil, self)
		if self.wndMain == nil then
			Apollo.AddAddonErrorText(self, "Could not load the main window for some reason.")
			return
		end
		
	    self.wndMain:Show(false, true)
	
		self.mmtimers = {}
    	self.startTime = nil


		-- if the xmlDoc is no longer needed, you should set it to nil
		-- self.xmlDoc = nil
		
		-- Register handlers for events, slash commands and timer, etc.
		-- e.g. Apollo.RegisterEventHandler("KeyDown", "OnKeyDown", self)
		Apollo.RegisterTimerHandler("OneSecTimer", "OnTimer", self)
		Apollo.RegisterSlashCommand("wc", "OnWalatikiCommanderOn", self)
		self.MMunearthedTimeDropped = nil


		-- Do additional Addon initialization here
	end
end

-----------------------------------------------------------------------------------------------
-- WalatikiCommander Functions
-----------------------------------------------------------------------------------------------
-- Define general functions here

-----------------------------------------------------------------------------------------------
-- Commented out for releace
------------------------------Comment Start-----------------------------------------------------------------

--function round(num, idp)
  --local mult = 10^(idp or 0)
  --return math.floor(num * mult + 0.5) / mult
--end

--------------------------------Comment End----------------------------------------------------------------

-- on SlashCommand "/wc"
function WalatikiCommander:OnWalatikiCommanderOn()
	if self.wndMain:IsShown(false) then
---		Apollo.AddAddonErrorText(self, "Found window, closing!")
		self.wndMain:Show(false)
	else
---		Apollo.AddAddonErrorText(self, "Didn't find window, opening")
		self.wndMain:Show(true)
	end
end


-----------------------------------------------------------------------------------------------
-- WalatikiCommanderForm Functions
-----------------------------------------------------------------------------------------------
-- when the Cancel button is clicked
function WalatikiCommander:OnCancel()
	self.wndMain:Show(false) -- hide the window
end

function WalatikiCommander:OnCmdButton( wndHandler, wndControl, eMouseButton )
	local cmd = wndControl:GetName()
	
	if cmd == "West" then
		ChatSystemLib.Command('/Instance ' .. sCmdNewMaskWest)
	elseif cmd == "Center" then
		ChatSystemLib.Command('/Instance ' .. sCmdNewMaskCenter)
	elseif cmd == "Top" then
		ChatSystemLib.Command('/Instance ' .. sCmdNewMaskTop)
	elseif cmd == "East" then
		ChatSystemLib.Command('/Instance ' .. sCmdNewMaskEast)
	elseif cmd == "30" then
		ChatSystemLib.Command('/Instance ' .. sCmdNewMask30)
	elseif cmd == "15" then
		ChatSystemLib.Command('/Instance ' .. sCmdNewMask15)
	elseif cmd == "5" then
		ChatSystemLib.Command('/Instance ' .. sCmdNewMask5)
	elseif cmd == "Defend" then
		ChatSystemLib.Command('/Instance ' .. sCmdDefCarrier)
	elseif cmd == "DefendTunnel" then
		ChatSystemLib.Command('/Instance ' .. sCmdDefTunnel)
	elseif cmd == "DefendWest" then
		ChatSystemLib.Command('/Instance ' .. sCmdDefWest)
	elseif cmd == "DefendBridge" then
		ChatSystemLib.Command('/Instance ' .. sCmdDefBridge)
	elseif cmd == "DefendEast" then
		ChatSystemLib.Command('/Instance ' .. sCmdDefEast)
	elseif cmd == "Attack" then
		ChatSystemLib.Command('/Instance ' .. sCmdAttCarrier)
	elseif cmd == "AttackTunnel" then
		ChatSystemLib.Command('/Instance ' .. sCmdAttTunnel)
	elseif cmd == "AttackWest" then
		ChatSystemLib.Command('/Instance ' .. sCmdAttWest)
	elseif cmd == "AttackBridge" then
		ChatSystemLib.Command('/Instance ' .. sCmdAttBridge)
	elseif cmd == "AttackEast" then
		ChatSystemLib.Command('/Instance ' .. sCmdAttEast)
	elseif cmd == "Base" then
		ChatSystemLib.Command('/Instance ' .. sCmdDef)
	elseif cmd == "Base1" then
		ChatSystemLib.Command('/Instance ' .. sCmdDef1)
	elseif cmd == "Base2" then
		ChatSystemLib.Command('/Instance ' .. sCmdDef2)
	elseif cmd == "Base3" then
		ChatSystemLib.Command('/Instance ' .. sCmdDef3)
	elseif cmd == "Base4" then
		ChatSystemLib.Command('/Instance ' .. sCmdDef4)
	elseif cmd == "Steal" then
		ChatSystemLib.Command('/Instance ' .. sCmdSteal)
	elseif cmd == "Steal1" then
		ChatSystemLib.Command('/Instance ' .. sCmdSteal1)
	elseif cmd == "Steal2" then
		ChatSystemLib.Command('/Instance ' .. sCmdSteal2)
	elseif cmd == "Steal3" then
		ChatSystemLib.Command('/Instance ' .. sCmdSteal3)
	elseif cmd == "Steal4" then
		ChatSystemLib.Command('/Instance ' .. sCmdSteal4)
	elseif cmd == "TargetHeal" then
			if not GameLib.GetTargetUnit() then
				ChatSystemLib.PostOnChannel(3,"[WC] : No target selected to heal") else
					ChatSystemLib.Command('/Instance Heal ' .. GameLib.GetTargetUnit():GetName())
			end
	elseif cmd == "TargetAssist" then
				if not GameLib.GetTargetUnit() then
					ChatSystemLib.PostOnChannel(3,"[WC] : No target selected to assist") else
						ChatSystemLib.Command('/Instance Assist ' .. GameLib.GetTargetUnit():GetName())
				end
	elseif cmd == "TargetAttack" then
				if not GameLib.GetTargetUnit() then
					ChatSystemLib.PostOnChannel(3,"[WC] : No target selected to attack") else
						ChatSystemLib.Command('/Instance Kill ' .. GameLib.GetTargetUnit():GetName())
				end
	elseif cmd == "TargetCC" then
				if not GameLib.GetTargetUnit() then
					ChatSystemLib.PostOnChannel(3,"[WC] : No target selected to CC") else
						ChatSystemLib.Command('/Instance CC ' .. GameLib.GetTargetUnit():GetName())
				end
	end
end


-----------------------------------------------------------------------------------------------
-- Creates a timer based on the drop time of a moodie mask.
-- Commented out for releace
-------------------------------Comment Start----------------------------------------------------------------

--function WalatikiCommander:OnTimer()
--	self:CheckUnearthedDespawns()
--	if self.wndMain:FindChild("TimersWindow") then
--		self.wndMain:FindChild("TimersWindow"):Destroy()
--		local timerInstance = Apollo.LoadForm(self.xmlDoc, "WalatikiCommanderForm.TimersWindow", self.wndMain, self)
--		timerInstance:FindChild("Timer"):SetText("Timers")
--		for _,time in pairs(self.mmtimers) do
--			local dTime = round(60 - (GameLib.GetGameTime() - time))
--			if dTime > 0 then
--				local timerInstance = Apollo.LoadForm(self.xmlDoc, "WalatikiCommanderForm.TimersWindow", self.wndMain, self)
--				timerInstance:FindChild("Timer"):SetText(dTime)
--			else
--			end
--		end
--		self.wndMain:ArrangeChildrenVert(0)
--	else
--	end
--end


----------------------------------------------------------------------------------------------

--function WalatikiCommander:CheckUnearthedDespawns()
--	if self.unearthedDropppedTime then
--		if (GameLib.GetGameTime() - self.unearthedDropppedTime) > 30 then
--			table.insert(self.mmtimers, GameLib.GetGameTime())
--			self.MMunearthedTimeDropped = nil
--		end
--	end
--end

--function WalatikiCommander:UnearthedDropped()
--	self.MMunearthedTimeDropped = GameLib.GetGameTime()
--end

--function WalatikiCommander:UnearthedPickedUp()
--	self.MMunearthedTimeDropped = nil
--end
 
--function WalatikiCommander:OnChatMessage(channelCurrent, tMessage)
--	if channelCurrent:GetName() == "Datachron" then
--		local message = tMessage.arMessageSegments[1].strText
--		if message == "The Dominion captured a Moodie Mask!" or message == "The Exiles captured a Moodie Mask!" then
--			table.insert(self.mmtimers, GameLib.GetGameTime())
--		elseif message == "A Moodie Mask has been unearthed!"  then
--			self:Window()
--		elseif message == "The Dominion gathered a Moodie Mask!" or message == "The Exiles gathered a Moodie Mask!" then
--			self:UnearthedPickedUp()
--		elseif message == "The Dominion dropped a Moodie Mask!" or message == "The Exiles dropped a Moodie Mask!" then
--			self:UnearthedDropped()
--		else
--			Print(message)
--		end
--	end
--end

------------------------------------Comment End-----------------------------------------------------------



-----------------------------------------------------------------------------------------------
-- WalatikiCommander Instance
-----------------------------------------------------------------------------------------------
local WalatikiCommanderInst = WalatikiCommander:new()
WalatikiCommanderInst:Init()
